package com.chuanxia.mcp.sched;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import java.io.*;
import java.nio.file.Files;
import java.util.Objects;

@Slf4j
@Component
@RequiredArgsConstructor
public class M3U8Utils {

    private final RestTemplate restTemplate;

    @Value("${m3u8.downLoadPath}")
    private String downLoadPath;
    @Value("${m3u8.tsDownLoadPath}")
    private String tsDownLoadPath;

    /**
     * 下载m3u8文件，包含key的下载地址(如果有) 和 ts文件名
     */
    public String downloadM3U8(String url, String videoId) {
        log.info("-- 开始下载 m3u8 --");
        ResponseEntity<byte[]> forEntity = restTemplate.getForEntity(url, byte[].class);
        //log.info("m3u8 内容 = {}", new String(forEntity.getBody()));
        String m3u8Path = downLoadPath + videoId + ".m3u8";
        File file = new File(m3u8Path);
        try {
            Files.write(file.toPath(), Objects.requireNonNull(forEntity.getBody(), "未获取到文件"));
        } catch (IOException e) {
            e.printStackTrace();
        }
        return new String(forEntity.getBody());
    }

}
